module.exports = [
  [
    [
      /\b(?:import|package)\b/g,
      'preproc',
      -1
    ],
    [
      /\/\/\//g,
      'comment',
      1
    ],
    [
      /\/\//g,
      'comment',
      7
    ],
    [
      /\/\*\*/g,
      'comment',
      8
    ],
    [
      /\/\*/g,
      'comment',
      9
    ],
    [
      /\b[+-]?(?:(?:0x[A-Fa-f0-9]+)|(?:(?:[\d]*\.)?[\d]+(?:[eE][+-]?[\d]+)?))u?(?:(?:int(?:8|16|32|64))|L)?\b/g,
      'number',
      -1
    ],
    [
      /"/g,
      'string',
      10
    ],
    [
      /'/g,
      'string',
      11
    ],
    [
      /(\b(?:class|trait))([ \t]+)([$A-Za-z0-9_]+)/g,
      ['keyword', 'normal', 'classname'],
      -1
    ],
    [
      /abstract|case|catch|class|def|do|else|extends|false|final|finally|for|forSome|if|implicit|import|lazy|match|new|null|object|override|package|private|protected|requires|return|sealed|super|this|throw|trait|try|true|type|val|var|while|with|yield|_|:|=>|=|<-|<:|<%|>:|#|@/g,
      'keyword',
      -1
    ],
    [
      /\b(?:Int|Byte|Boolean|Char|Long|Float|Double|Short|Nil)\b/g,
      'type',
      -1
    ],
    [
      /~|!|%|\^|\*|\(|\)|-|\+|=|\[|\]|\\|:|;|,|\.|\/|\?|&|<|>|\|/g,
      'symbol',
      -1
    ],
    [
      /\{|\}/g,
      'cbracket',
      -1
    ],
    [
      /(?:[A-Za-z]|_|[`~!@#$%&*()_=+{}|;:",<.>\/?'\\[\]\^\-])(?:[A-Za-z0-9_]|[`~!@#$%&*()_=+{}|;:",<.>\/?'\\[\]\^\-])*(?=[ \t]*\()/g,
      'function',
      -1
    ]
  ],
  [
    [
      /$/g,
      null,
      -2
    ],
    [
      /(?:<?)[A-Za-z0-9_\.\/\-_~]+@[A-Za-z0-9_\.\/\-_~]+(?:>?)|(?:<?)[A-Za-z0-9_]+:\/\/[A-Za-z0-9_\.\/\-_~]+(?:>?)/g,
      'url',
      -1
    ],
    [
      /<\?xml/g,
      'preproc',
      2,
      1
    ],
    [
      /<!DOCTYPE/g,
      'preproc',
      4,
      1
    ],
    [
      /<!--/g,
      'comment',
      5
    ],
    [
      /<(?:\/)?[A-Za-z](?:[A-Za-z0-9_:.-]*)(?:\/)?>/g,
      'keyword',
      -1
    ],
    [
      /<(?:\/)?[A-Za-z](?:[A-Za-z0-9_:.-]*)/g,
      'keyword',
      6,
      1
    ],
    [
      /&(?:[A-Za-z0-9]+);/g,
      'preproc',
      -1
    ],
    [
      /<(?:\/)?[A-Za-z][A-Za-z0-9]*(?:\/)?>/g,
      'keyword',
      -1
    ],
    [
      /<(?:\/)?[A-Za-z][A-Za-z0-9]*/g,
      'keyword',
      6,
      1
    ],
    [
      /@[A-Za-z]+/g,
      'type',
      -1
    ],
    [
      /(?:TODO|FIXME|BUG)(?:[:]?)/g,
      'todo',
      -1
    ]
  ],
  [
    [
      /\?>/g,
      'preproc',
      -2
    ],
    [
      /([^=" \t>]+)([ \t]*)(=?)/g,
      ['type', 'normal', 'symbol'],
      -1
    ],
    [
      /"/g,
      'string',
      3
    ]
  ],
  [
    [
      /\\(?:\\|")/g,
      null,
      -1
    ],
    [
      /"/g,
      'string',
      -2
    ]
  ],
  [
    [
      />/g,
      'preproc',
      -2
    ],
    [
      /([^=" \t>]+)([ \t]*)(=?)/g,
      ['type', 'normal', 'symbol'],
      -1
    ],
    [
      /"/g,
      'string',
      3
    ]
  ],
  [
    [
      /-->/g,
      'comment',
      -2
    ],
    [
      /<!--/g,
      'comment',
      5
    ]
  ],
  [
    [
      /(?:\/)?>/g,
      'keyword',
      -2
    ],
    [
      /([^=" \t>]+)([ \t]*)(=?)/g,
      ['type', 'normal', 'symbol'],
      -1
    ],
    [
      /"/g,
      'string',
      3
    ]
  ],
  [
    [
      /$/g,
      null,
      -2
    ]
  ],
  [
    [
      /\*\//g,
      'comment',
      -2
    ],
    [
      /(?:<?)[A-Za-z0-9_\.\/\-_~]+@[A-Za-z0-9_\.\/\-_~]+(?:>?)|(?:<?)[A-Za-z0-9_]+:\/\/[A-Za-z0-9_\.\/\-_~]+(?:>?)/g,
      'url',
      -1
    ],
    [
      /<\?xml/g,
      'preproc',
      2,
      1
    ],
    [
      /<!DOCTYPE/g,
      'preproc',
      4,
      1
    ],
    [
      /<!--/g,
      'comment',
      5
    ],
    [
      /<(?:\/)?[A-Za-z](?:[A-Za-z0-9_:.-]*)(?:\/)?>/g,
      'keyword',
      -1
    ],
    [
      /<(?:\/)?[A-Za-z](?:[A-Za-z0-9_:.-]*)/g,
      'keyword',
      6,
      1
    ],
    [
      /&(?:[A-Za-z0-9]+);/g,
      'preproc',
      -1
    ],
    [
      /<(?:\/)?[A-Za-z][A-Za-z0-9]*(?:\/)?>/g,
      'keyword',
      -1
    ],
    [
      /<(?:\/)?[A-Za-z][A-Za-z0-9]*/g,
      'keyword',
      6,
      1
    ],
    [
      /@[A-Za-z]+/g,
      'type',
      -1
    ],
    [
      /(?:TODO|FIXME|BUG)(?:[:]?)/g,
      'todo',
      -1
    ]
  ],
  [
    [
      /\*\//g,
      'comment',
      -2
    ],
    [
      /(?:<?)[A-Za-z0-9_\.\/\-_~]+@[A-Za-z0-9_\.\/\-_~]+(?:>?)|(?:<?)[A-Za-z0-9_]+:\/\/[A-Za-z0-9_\.\/\-_~]+(?:>?)/g,
      'url',
      -1
    ],
    [
      /(?:TODO|FIXME|BUG)(?:[:]?)/g,
      'todo',
      -1
    ]
  ],
  [
    [
      /"/g,
      'string',
      -2
    ],
    [
      /\\./g,
      'specialchar',
      -1
    ]
  ],
  [
    [
      /'/g,
      'string',
      -2
    ],
    [
      /\\./g,
      'specialchar',
      -1
    ]
  ]
];
